int rate_fit()
{
    TH1D *np = new TH1D("np","np",1000,0,1000);
    TH1D *np2 = new TH1D("np2","np2",1000,0,1000);

  TCanvas* myc1 =new TCanvas();
  myc1->cd();
  myc1->SetFillColor(kWhite);
  myc1->SetTicks(1);
//  myc1->SetLogx();
//  myc1->SetLogy();
  myc1->Update();
  myc1->SetLeftMargin(0.13);
//  myc1->SetRightMargin(0.05135952);
//  myc1->SetTopMargin(0.04910714);
  myc1->SetBottomMargin(0.15);
  
//  np->SetAxisRange(400,1e6,"x");

  //np->SetAxisRange(2e-1,2e3,"y");
  np->SetStats(kFALSE);
  np->SetTitle("");
  np->SetTitleSize(1.5,"X");
  np->SetTitleSize(1.5,"Y");
  
  np->SetXTitle("kT [keV]");
  np->SetTitleOffset(1.1);
  np->SetYTitle("DECAY CONSTANT [1/s]");
  np->SetMarkerStyle(21);
  np->SetMarkerSize(0.7);
  np->GetXaxis()->SetLabelSize(0.06);
  np->GetYaxis()->SetLabelSize(0.06);
  np->GetXaxis()->SetTitleSize(0.06);
  np->GetYaxis()->SetTitleSize(0.06);
//  np->SetAxisRange(0,1000,"x");
  np->SetAxisRange(5,100,"x");
  np2->SetAxisRange(5,100,"x");
  np->Draw();

  TGraphErrors* s2;
  char* dstring = " kT (keV)             effective transition rate (1/s)";
  char* fname = "cl34/034Cl_level_001_to_level_002_effective_transition.dat";
  s2 = makedatahisto(fname, dstring , 5, np2);
  cout << " s2 done" << endl;

  TGraphErrors* s3;
//  char* dstring = " kT (keV)             effective transition rate (1/s)";
//  char* fname = "cl34/034Cl_level_001_to_level_002_effective_transition.dat";
  s3 = makedatahisto(fname, dstring , 3, np);
  cout << " s3 done" << endl;

//  TF1 *myfit = new TF1("myfit","exp([0]+[1]/x+[2]/x**(1./3.)+[3]*x**(1./3.)+[4]*x+[5]*x**(5./3.))", 10, 100) ;
  TF1 *myfit = new TF1("myfit","([0]+[1]/x+[2]/x**(1./3.)+[3]*x**(1./3.)+[4]*x+[5]*x**(5./3.)+[6]*log(x))", 5, 500) ;
  myfit->SetParameter(0, 1.);
  myfit->SetParameter(1, 0.);
  myfit->SetParameter(2, 0.);
  myfit->SetParameter(3, 0.);
  myfit->SetParameter(4, 0.);
  myfit->SetParameter(5, 0.);
  myfit->SetParameter(6, 0.);
  myfit->SetParName(0,"a0");
  myfit->SetParName(1,"a1");
  myfit->SetParName(2,"a2");
  myfit->SetParName(3,"a3");
  myfit->SetParName(4,"a4");
  myfit->SetParName(5,"a5");
  myfit->SetParName(6,"a6");
  myfit->SetLineColor(kBlue);
  np2->Fit("myfit");
  double param(7);
  TF1 *myfit2 = new TF1("myfit2","exp([0]+[1]/x+[2]/x**(1./3.)+[3]*x**(1./3.)+[4]*x+[5]*x**(5./3.)+[6]*log(x))", 5, 500) ;
  for (int i=0; i<7; i++) {
    param[i]=myfit->GetParameter(i);
    myfit2->SetParameter(i,param[i]);
    cout << param[i] << endl;
    }  
//  TF1 *myfit2 = new TF1("myfit2","exp(param[0]+param[1]/x+param[2]/x**(1./3.)+param[3]*x**(1./3.)+param[4]*x+param[5]*x**(5./3.)+param[6]*log(x))", 5, 500) ;
  
  
/*  
  float kt = 30.;
  TF1 *myfit = new TF1("myfit","[1]*x*exp(-x/[0])", 0, 100) ;
  myfit->SetParameter(0, kt);
  myfit->SetParameter(1, 1/kt*TMath::Exp(1));
  myfit->SetParName(0,"kT");
  myfit->SetParName(1,"Norm");
  myfit->SetLineColor(kBlue);
  np->Fit("myfit");

  TF1 *myfit1 = new TF1("myfit1","[1]*x*exp(-x/[0])", 0, 130) ;
  myfit1->SetParameter(0, kt);
  myfit1->SetParameter(1, 1/kt*TMath::Exp(1));
  myfit1->SetParName(0,"kT");
  myfit1->SetParName(1,"Norm");
  myfit1->SetLineColor(kRed);

*/

//  myfit->Draw("same");
  np->Draw();
  myfit2->Draw("same");

  //myG->Print();


/*
  theLegall = new TLegend(0.5,0.75,0.98,0.95);
  theLegall->SetTextSize(.05);
//  theLegall->AddEntry(np,"DANCE data","p");
//  theLegall->AddEntry(s_1,"1.912 MeV, ^{197}Au","p");
  theLegall->AddEntry(np,"E_{p} = 1912 #pm 50 keV","p");
//  theLegall->AddEntry(s_2,"1.912 MeV, ^{60}Fe","p");
//  theLegall->AddEntry(ratynski,"Ratynski","p");
//  theLegall->AddEntry(myfit1,"Maxwell kT=30 keV","l");
////////  theLegall->AddEntry(myfit,"Maxwell fit, kT = 33 keV","l");
//  theLegall->AddEntry(s_3,"1.912 MeV, ^{197}Au","p");
  theLegall->SetFillColor(kWhite);
  theLegall->Draw();

*/

}


TGraphErrors* makedatahisto( char* fname, char* diststring, int data_type, TH1D *h) 
{
  ifstream file (fname);
   string line;
   while (line.substr( 0, strlen(diststring)).compare( diststring)) 
	  	{
			getline( file, line);
//			cout << line << endl;
			}
				

   switch (data_type)
   {
     case 1:  // data has form: energy cross-section cross-section-error
       {
         TArrayF E,b,bE,EE;
         float vE, vb, vbE;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> vb >> vbE;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(vb,i);
           bE.AddAt(vbE,i);
           EE.AddAt(0.0,i);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 2:  // data has form:  E, n_gs, n_iso, n_gs + n_iso, n_gs_weighted, n_iso_weighted, n_gs_weighted + n_iso_weighted
       {
         TArrayF E,b,bE,EE;
         float vE, n_gs, n_iso, n_gs_iso, n_gs_weighted, n_iso_weighted, n_gs_iso_weighted;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> n_gs>> n_iso >> n_gs_iso >>n_gs_weighted >>n_iso_weighted >>n_gs_iso_weighted ;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(n_gs_iso_weighted,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           h->SetBinContent(i,n_gs_iso_weighted);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 3:  // data has form:  x, y
       {
         TArrayF E,b,bE,EE;
         float x,y;
         int i;
         i=0;
         while (file)
         {
           file >> x >> y;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(x,i);
           b.AddAt(y,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           h->SetBinContent(i,y);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 4:  // data has form:  E, n_gs, n_iso, n_gs + n_iso, n_gs_weighted, n_iso_weighted, n_gs_weighted + n_iso_weighted
       {
         TArrayF E,b,bE,EE;
         float vE, n_gs, n_iso, n_gs_iso, n_gs_weighted, n_iso_weighted, n_gs_iso_weighted;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> n_gs>> n_iso >> n_gs_iso >>n_gs_weighted >>n_iso_weighted >>n_gs_iso_weighted ;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(n_gs_iso,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           h->SetBinContent(i,n_gs_iso);
           h->SetBinError(i,0.001);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 5:  // data has form:  x, y -> x, ln y
       {
         TArrayF E,b,bE,EE;
         float x,y;
         int i;
         i=0;
         while (file)
         {
           file >> x >> y;
           y=TMath::Log(y);
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(x,i);
           b.AddAt(y,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           h->SetBinContent(i,y);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
       
   }
   return 0;

         

}

TGraphErrors* makedata( char* fname, char* diststring, int data_type)
{
  ifstream file (fname);
   string line;
   while (line.substr( 0, strlen(diststring)).compare( diststring)) 
	  	{
			getline( file, line);
//			cout << line << endl;
			}
				

   switch (data_type)
   {
     case 1:  // data has form: energy cross-section cross-section-error
       {
         TArrayF E,b,bE,EE;
         float vE, vb, vbE;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> vb >> vbE;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(vb,i);
           bE.AddAt(vbE,i);
           EE.AddAt(0.0,i);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 2:  // data has form:  E, n_gs, n_iso, n_gs + n_iso, n_gs_weighted, n_iso_weighted, n_gs_weighted + n_iso_weighted
       {
         TArrayF E,b,bE,EE;
         float vE, n_gs, n_iso, n_gs_iso, n_gs_weighted, n_iso_weighted, n_gs_iso_weighted;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> n_gs>> n_iso >> n_gs_iso >>n_gs_weighted >>n_iso_weighted >>n_gs_iso_weighted ;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(n_gs_iso_weighted,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 3:  // data has form:  x, y
       {
         TArrayF E,b,bE,EE;
         float x,y;
         int i;
         i=0;
         while (file)
         {
           file >> x >> y;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(x,i);
           b.AddAt(y,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
     case 4:  // data has form:  E, n_gs, n_iso, n_gs + n_iso, n_gs_weighted, n_iso_weighted, n_gs_weighted + n_iso_weighted
       {
         TArrayF E,b,bE,EE;
         float vE, n_gs, n_iso, n_gs_iso, n_gs_weighted, n_iso_weighted, n_gs_iso_weighted;
         int i;
         i=0;
         while (file)
         {
           file >> vE >> n_gs>> n_iso >> n_gs_iso >>n_gs_weighted >>n_iso_weighted >>n_gs_iso_weighted ;
           E.Set(i+1);
           b.Set(i+1);
           bE.Set(i+1);
           EE.Set(i+1);
           E.AddAt(vE,i);
           b.AddAt(n_gs_iso,i);
           bE.AddAt(0.0,i);
           EE.AddAt(0.0,i);
           ++i;
         }
         TGraphErrors* theG = new TGraphErrors(i,E.GetArray(),b.GetArray(),EE.GetArray(),bE.GetArray());
         return theG;
       };
       
   }
   return 0;

         

}

